

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


#ifndef ONEWIRE_H_
#define ONEWIRE_H_

#include <avr/io.h>

//----------------------------------------------------------------------//
/*
#define	ONEWIREUP_PORT	PORTD		// Port silnego podcigania, moe by ten sam pin co linia RxD
#define	ONEWIREUP_DDR	DDRD		// W trybie pio moe by taka sama deklaracja jak ONEWIRE_DQ
#define ONEWIREUP_DQ	PD0
#define	ONEWIREUP_RXD				// Uycie deklaracji definuje port PullUp na lini USART-a (wane gdy zdefinowano ONEWIRE_UART)

//#define	ONEWIRE_OVERDRIVE_OFF	// Zablokowanie trybu overdrive


//---------------------- deklaracje uywane w trybie USART --------------//
//#define	ONEWIRE_UART	0			// Uart obsugujcy magistral (brak to tryb PIO)
//#define	ONEWIRE_UART	2480		// Konwerter UART 2 1-Wire
//#define	ONEWIRE_UART	2482		// Konwerter IIC 2 1-Wire
	// Brak jednej z powyszych definicji obsuy magistral programowo (tryb PIO -  definicje niej)


//---------------------- deklaracje uywane w trybie PIO ---------------//
#define ONEWIRE_PORT	PORTD
#define ONEWIRE_DDR		DDRD
#define ONEWIRE_PIN		PIND
#define ONEWIRE_DQ 		PD0
#define	ONEWIRE_IRQ			0	// 2 - blokowanie IRQ na czas obsugi caej transmisji 1-Wire
								// 1 - na czas transmisji bajtu
								// 0 - na czas transmisji bitu
#define	ONEWIRERTS_IRQ		0	// Wczenie IRQ podczas sekwencji reset
								// im duej wykonuj sie przerwania tym wyszy trzeba wpisa poziom

*/


//=======================================================================//
byte onewireOverdrive = FALSE;		// Aktualnie tryb szybki wyczony
byte onewirePullup = TRUE;			// Podciganie wczone (w DS2480 zawsze)
byte onewireStrong = TRUE;			// Silne podciganie wczone (tylko DS2482) w DS2480 aby silnie podcign trzeba wywoa onewirePulse(5);
byte onewireFlexible = FALSE;		// Transmisja na liniach o duej pojemnoci wyczona (tylko DS2480) wczenie zablokuje overdrive
byte onewireVppErr = 0;				// Kod bdu napicia Vpp
byte onewireRstSt = 0;				// Status resetu 0-OK, 1-presence, 2-alarm, 3-uszkodzona magistrala
#define	OW_ERRVPP_VOLTAGE		1	// Wybrano niedopuszczalne napiecie programujace
#define	OW_ERRVPP_FAULT			2	// Brak napicia programujcego (np z przetwornicy)
#define	OW_ERRVPP_DRIVER		3	// Brak napicia na magistrali, uszkodzony tranzystor sterujcy lub DS28480


//=======================================================================//
#ifdef ONEWIRE_UART
  #define	OWDELAYPULLUP	60 * 4		// Czas w us na naadowanie magistrali do odczytu
#else
  #define	OWDELAYPULLUP	1
#endif
#define OWOVT_RST	120					// Czas overtime w 10us (musi by wikszy ni 1/(9600/10)
#define OWOVT_BIT	120					// Czas overtime w us (musi by wikszy ni 1/(115200/10)


//commands
#define ONEWIRE_CMD_READROM			0x33
#define ONEWIRE_CMD_MATCHROM		0x55
#define ONEWIRE_CMD_SKIPROM			0xcc
#define ONEWIRE_CMD_SKIP			0xcc
#define ONEWIRE_CMD_SEARCHROM		0xf0
#define ONEWIRE_CMD_SEARCH			0xf0
#define ONEWIRE_CMD_ALARMSEARCH		0xec

#define ONEWIRE_CMD_RESUME			0xA5	// Zamiast MATCHROM w trybie szybkiej komunikacji
#define ONEWIRE_OVD_RESUME			0xA5	// Zamiast MATCHROM w trybie szybkiej komunikacji
#define ONEWIRE_OVD_SKIPROM			0x3C	// Przejcie do szybkiej komunikacji
#define ONEWIRE_OVD_MATCHROM	 	0x69	// Przejcie do szybkiej komunikacji


//=======================================================================//
#ifndef ONEWIRE_UART
  #define	ONEWIRE_OVERDRIVE		// Tryb overdrive moliwy dla trybu PIO
#endif

#ifdef ONEWIRE_OVERDRIVE_OFF
  #undef	ONEWIRE_OVERDRIVE
  #undef	ONEWIRE_OVD_SKIPROM		// Overdrive skip rom zastpujemy przez skip-rom
  #define	ONEWIRE_OVD_SKIPROM		0xcc
  #undef	ONEWIRE_CMD_RESUME
  #undef	ONEWIRE_OVD_MATCHROM
#endif


//----------------------------------------------------------------------//
byte onewireTest();


#warning "USER: init ma konfigurowac DS248x"
extern byte onewireInit();
extern byte onewireTest();
extern uint8_t onewireReset();
extern uint8_t onewireResetSTD();
extern uint8_t onewireResetOVD();
extern uint8_t onewireReadBit(void );
extern void onewireStrongPullup( byte pullup );
extern void onewriteMatchRom( byte *buf );
extern void onewriteMatchRomOVD( byte *buf );
extern uint8_t onewire_crc8_update(uint8_t crc, uint8_t data);
extern byte OWtestOverdrive();
extern byte onewirePulse( byte vpp, word czas );
extern void onewriteOverdriveOnOff( byte ovd );


/******************************************************************/
#endif
